Main:
   call InitSensors(0,0,0,90) // set offsets   
   while true
     call Orientation(Forw,Side,Rot,Heading)  
     // display the entire array  
     for i=0 to 6
        xyString 10,10+20*i,i; Sensors[i];" "
     next   
     // display the processed readings
     xyString 10,160,"Forward Tilt    = ",Forw;" "
     xyString 10,180,"Side Tilt       = ",Side;" "
     xyString 10,200,"Rotational Tilt = ",Rot;" "
     xyString 10,220,"Compass Heading = ",Heading;" "  
   wend  
end
   
sub InitSensors(a,b,c,d)
  // The Utility MUST reside in the same directory as
  // the application unless you set up paths
  
  print "Initializing..."
  SetCBtext("stop") // stop utility if running
  filerename ("RBsTurn.txt","SensorsTurn.txt")
  delay 100
  Spawn ("RBsensorUtility.exe","",P_NOWAIT) 
  // provide time for Utility to spawn
  delay 1000 
  ClearScr   
  //  The above code can be eliminated if you always
  //  start the Utility manually. We have code in
  //  the utility that SHOULD prevent a second copy
  //  from running - but for some unknown reason it
  //  is not 100% reliable.  The above code seems to
  //  always work on our machine.
  dim Sensors[28] //max available from utility
  dim Offsets[4]                 
  for i=0 to 27
    Sensors[i]=""
  next
  // allow setting certain angles to zero
  Offsets[0]=a
  Offsets[1]=b
  Offsets[2]=c
  Offsets[3]=d 
  // note: new initialization will be added here for voice commands 
return  

sub Orientation(&t1,&t2,&t3,&h)
   // Request readings
   SetCBtext("tilt")
   filerename ("RBsTurn.txt","SensorsTurn.txt")
   // and wait for it to respond
   while !fileexists("RBsTurn.txt") 
   wend
   delay 10
   // get the data
   s=getcbtext()
   // and parse it
   mfromstring Sensors,s,"," 
   t1 = round(Sensors[1])+Offsets[0]
   t2 = round(Sensors[2])+Offsets[1]
   t3 = round(Sensors[3])+Offsets[2]
   h  = round(Sensors[5])+Offsets[3]
   // ensure heading within normal range
   if h>359 then h-=360
   if h<0 then h+=360
return


